;Frekvence krystalu 4Mhz, t.j. 1 instrukce = 1 mikrosec. casovac je inkrementovan 
;po 1 mikrosekunde
;hotovo nacitani do RAM ,zaznam do EEPROM,porovnani dat pri prijmu s daty v RAM
 


        LIST P=16F628, R=DEC    ; Use the PIC16F628 and decimal system 

        #include "P16F628.INC"  ; Include header file 

        __config  _HS_OSC &_LVP_OFF & _WDT_OFF & _PWRTE_ON & _BODEN_ON 

         
	constant initmrhi=0C7H		;pro test 00 predvolba timeru low
;	constant initmrhi=0F5H		;pro test 00 predvolba timeru low - pro ovl. od kamery ap.
	

vys		equ	20H	;promenna pro ulozeni nizsiho byte timeru
tmp		equ	21H	;promenna pro ulozeni vyssiho byte timeru
TMPW		equ	22H	;docasna promenna pro ulozeni W v int.
TMPS		equ	23H	;totez jako vyse pro ulozeni status
flags		equ	24H	;registr pro flagy
AD0		equ	26H	;adresa prvniho byte zaznamu v RAM
ok		equ	01H	;flag porovnani hodnoty
err		equ	02H	;flag porovnani hodnoty
stisk	equ	03H
druhy_kod	equ	04H
ulozeno	equ	05H
citac	equ	25H

#define	tlacitko	PORTB,1	;pokud je v L, bude se zaznamenavat do RAM infra kod
#define LED		PORTA,1	;LED indikujici prijeti spravneho kodu
#define LED_EEPROM	PORTA,0	;LED indikujici dokonceni zapisu do EEPROM 


 ORG    0x000            	; Program starts at 0x000 
 	goto init
	ORG 4			;preruseni
	goto int1

int1
;-------------uloz data-----------------
	movwf	TMPW		; ulozi W
	swapf	STATUS,W	; prohodi nibble STATUS a ulozi do W
	bcf	STATUS,RP0	; nastaveni banky 0
	movwf	TMPS		; ulozit STATUS
;---------------------------------------
	bcf STATUS, RP0 ; Bank0
	btfsc INTCON,T0IF 	;prislo preruseni od preteceni casovace?
	goto timer		;ano,obsluz
	bcf INTCON,INTF 	; nulovn prznaku preruen od external
	bcf	INTCON,T0IE	;zakaz int od casovace
	movf	citac,W
	sublw	0C0H		;test prvniho byte, ten neni platny zahodi se (hodnota ve vyssim nibble nulova)
	btfsc	STATUS,C
	goto	out	
	movf	citac,W		;obnov data
	
	btfss	tlacitko	;test bitu,pokud je v nule,zaznamenava data do RAM
	goto	zaznam_01
	goto	porovnej
	
;zaznam dat do RAM
zaznam_01
	bcf		flags,stisk		;shodi priznak dalsiho preteceni casovace
	btfsc	flags,druhy_kod
	goto	zaznam_02

	incf	FSR
	movwf	INDF		;uloz hodnotu na misto indexovane FSR
out	call 	timini		;nacti predvolbu
	bsf	INTCON,T0IE	;povol int od casovace
	goto	IntRet		;8
zaznam_02
	incf	FSR
	movf	FSR,W		;uschovej FSR
	movwf	tmp
	addlw	7BH
	movwf	FSR
	movf	citac,W		;obnov data
	movwf	INDF		;uloz hodnotu na misto indexovane FSR
	movf	tmp,W
	movwf	FSR
	goto	out
;porovna hodnotu,pokud je rovno nastavi priznak ok
porovnej	bcf	flags,stisk			;shodi priznak dalsiho preteceni casovace
			incf	FSR
			movf	FSR,W			;uschovej 
			movwf	tmp			;v TMP je FSR
			movlw	25H			;proved presun na adresu v EEPROM (26H v FSR = 01H v EEPROM pro prvni kod)
			subwf	tmp,W
			
;********************   Cten dat z EEPROM    ********************
			
			bsf	STATUS,RP0	; banka 1	!!! nastav EEADR !!!
			movwf	EEADR
			bsf	EECON1,RD	; precte EEPROM
			movf	EEDATA,W	; EEDATA -> W
			bcf	STATUS,RP0	; banka 0
			movwf	tmp		;uloz data z EEPROM do tmp
			movf	citac,W		;nacti data z casovace
			subwf	tmp,W		;od W odecte INDF
  			btfsc	STATUS,Z	;testuj nulovost,nula je ok
			goto	pokr_03
			
;==============zkus odecet dat z RAM page 1 a pokud i tam nebude uspech, je to neplatny povel - chyba =========
			movf	FSR,W		;uschovej FSR
			movwf	tmp
			addlw	1BH		;pricti pro adresaci v druhe casti EEPROM, 26H+1BH=41H adresa prvniho zaznamu v druhe casti
		
;********************   Cten dat z EEPROM    ********************
			
			bsf	STATUS,RP0	; banka 1	!!! nastav EEADR !!!
			movwf	EEADR
			bsf	EECON1,RD	; precte EEPROM
			movf	EEDATA,W	; EEDATA -> W
			bcf	STATUS,RP0	; banka 0
			movwf	tmp		;uloz data z EEPROM do tmp
			movf	citac,W		;nacti data z casovace
			subwf	tmp,W		;od W odecte INDF
  			btfsc	STATUS,Z	;testuj nulovost,nula je ok
			goto	pokr_03
			goto	spatne

pokr_03			call 	timini		;nacti predvolbu
			bsf	INTCON,T0IE	;povol int od casovace
			goto	IntRet
		
;nuluje priznak ok pokud se data v RAM nerovnaji nactenym
spatne			bsf	flags,err	;
			call 	timini		;nacti predvolbu
			bsf	INTCON,T0IE	;povol int od casovace
			goto	IntRet

;----------natahni data zpet-----------------------
        
IntRet swapf TMPS,W ; pvodn registr STATUS do W 
  movwf STATUS ; navrcen registru STATUS 
  swapf TMPW,F ; prprava pvodnho registru W 
  swapf TMPW,W ; nvrat pvodnho registru W 
  retfie 

;timer pretece po konci telegramu
timer			bcf INTCON,T0IF 	; nulovn prznaku preruen 
			incf	citac,F		;inkrementuj software casovac 
			movf	citac,W		;nacti
			btfss	STATUS,Z	;testuj preteceni
			goto	IntRet		;nepretekl, ven, pretekl, pokracuj dal
			
;=======CASOVAC PRETEKL t.j. ukonceni serie impulsu=======================	
			
			btfss	flags,stisk		;podruhe preteceni bez prichodu impulsu, t.j. tlacitko na DO uvolneno
			goto	pokr_01			
			bcf	INTCON,T0IE		;zakaz int od casovace-vypni casovac
			btfsc	tlacitko
			goto	zhasni
			btfss	flags,druhy_kod		
			goto	pokr_05
			call	zapisEEPROM			;zapis kodu z RAM do EEPROM - 2.kod
			bcf	flags,druhy_kod
			goto	zhasni	
			
pokr_05	
			call	zapisEEPROM			;zapis kodu z RAM do EEPROM - 1.kod
			bsf	flags,druhy_kod			
			goto	zhasni
			
pokr_01			movf	FSR,W		;pri jednom pulsu na vstupu se spusti  casovac a pretece, pak doslo k "sepnuti"
			sublw	25H		;zde se otestuje, zda slo jen o jeden puls (neni inkrementovan FSR) pokud ano,	
			btfss	STATUS,Z	;provede se osetreni. Pokud slo o vice rusivych pulsu, je to osetreno standardne jako 
			btfsc	flags,err
			goto	zhasni
			bsf	LED
			goto 	konec
zhasni			bcf	LED
			bcf	flags,err
konec			movlw	25H		;nacti pocatecni pozici pro indirect addresing
			movwf	FSR
			bsf	flags,stisk
			goto	IntRet

;********************   Zpis dat do EEPROM   ********************
zapisEEPROM
		bsf	LED_EEPROM
		movlw	25H			;nastav ukazatel na dat v RAM prvni kod
		btfsc	flags,druhy_kod		;testuj odkud a kam zapsat,pokud je nastaven,provede se zapis prvnich dat do prvni casti EEPROM
		addlw	7BH			;pokud je pozadavek nacitani dat druheho kodu, pricti k ukazateli cislo pro prechod do druhe banky RAM
		movwf	FSR			;uloz do ukazatele
		
		clrW
		btfsc	flags,druhy_kod	;testuj odkud a kam zapsat,pokud je nastaven,provede se zapis prvnich dat do prvni casti EEPROM
		movlw	40H			;pokud jde o zaznam do prvni casti EEPROM,uloz do EEADR 0, pujde o zaznam od adresy 1
		bsf	STATUS,RP0	; banka 1	!!! nastav EEADR a EEDATA !!!
		movwf	EEADR		;pokud jde o zaznam do druhe casti EEPROM,uloz do EEADR 40, pujde o zaznam od adresy 41
		bcf	STATUS,RP0		
		clrf	tmp		;nuluj pocitadlo obehu zapisu
			
opak		incf 	FSR,F		;zvys FSR
		incf	tmp,F
		movf	tmp,W
		xorlw	40H		;testuj dosazeni konce
		btfsc	STATUS,Z
		goto	konec_zapisu

	bcf	INTCON,GIE		; !!! zakazano preruseni !!!
	movf	INDF,W			;nacti aktualni hodnotu	
	bsf	STATUS,RP0		; banka 1	!!! nastav EEADR a EEDATA !!!
	movwf	EEDATA			; !!! W -> EEDATA !!!
	incf	EEADR,F
	bsf	EECON1,WREN		; povolit zapis do EEPROM
;       ------------------------	; aktivace zapisu
	movlw	0x55			; povinna povolovaci sekvence
	movwf	EECON2
	movlw	0xAA
	movwf	EECON2
	bsf	EECON1,WR		; spustit zapis
;       ------------------------	; konec aktivace
	btfsc	EECON1,WR		; pockat na konec zapisu
	goto	$-1			; =1
	bcf	EECON1,WREN		; zakazat zapis do EEPROM
	bcf		STATUS,RP0	; banka 0
	goto	opak

konec_zapisu	
	bcf	LED_EEPROM
	bsf	INTCON,GIE		; !!! povoleni preruseni !!!
;-------------------------------
	return

; --------------------------------
; SET ANALOG/DIGITAL INPUTS PORT A
; --------------------------------
;
init	movlw 7
	movwf CMCON			; CMCON=7 set comparators off         
; 
; ---------------- 
; INITIALIZE PORTS
; ---------------- 
; 
	bcf STATUS,RP0		;banka 0
	movlw b'00000000'   	;set up portA
	movwf PORTA	
        
	movlw b'00000011'	; RB2(TX)=1 others are 0
    movwf PORTB
    bsf STATUS,RP0          	; RAM PAGE 1
	bcf OPTION_REG, 7	; enable internal pullups
	bcf	OPTION_REG,INTEDG

    movlw b'00000000'
    movwf TRISA			; portA

;----------PORT B-----------------------
    movlw b'00000011'		;  input 
    movwf TRISB
; ---------------- 
; INITIALIZE TIMERU / timer 0 is 8 bits timer
; ---------------- 
 	bcf OPTION_REG,PSA ; nastaven registru OPTION 
	bcf	OPTION_REG,PS0
	bcf	OPTION_REG,PS1
	bcf	OPTION_REG,PS2
	
	bcf	OPTION_REG,T0CS
	bcf INTCON,T0IF 

; Initialize the Special Function Registers (SFR) interrupts
	bcf STATUS, RP0 	; Bank0
	bsf INTCON, PEIE 	; Enable all unmasked Peripheral Interrupts
	bsf INTCON, INTE 	; Enable Peripheral Interrupt RB0
	bsf INTCON, GIE 	; Enable all Interrupts
	bcf	STATUS,IRP	;
	movlw	25H
	movwf	FSR
	clrf	citac
	clrf	TMR0
	bcf	flags,druhy_kod
	
	goto $
	
 timini	
 	MOVLW initmrhi ; natahni predvolbu high
	MOVWF citac
	CLRF	TMR0
	return

        END
